## cpp-jwt 1.4%2Bds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(cpp-jwt VERSION 1.2.0)

option(CPP_JWT_BUILD_EXAMPLES "build examples" ON)
option(CPP_JWT_BUILD_TESTS "build tests" ON)
option(CPP_JWT_USE_VENDORED_NLOHMANN_JSON "use vendored json header" ON)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR})
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_BINARY_DIR})

# only set compiler flags if we are the main project, otherwise let the main
# project decide on the flags
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_CXX_COMPILER_ID}"
                                                  MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
  endif()

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()

endif()

find_package(OpenSSL REQUIRED)

if(NOT CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
  find_package(nlohmann_json REQUIRED)
endif()

# ##############################################################################
# LIBRARY
# ##############################################################################

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(
  ${PROJECT_NAME}
  INTERFACE $<BUILD_INTERFACE:${${PROJECT_NAME}_SOURCE_DIR}/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_link_libraries(${PROJECT_NAME} INTERFACE OpenSSL::SSL)
if(NOT CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
  target_link_libraries(${PROJECT_NAME} INTERFACE nlohmann_json::nlohmann_json)
else()
  add_definitions(-DCPP_JWT_USE_VENDORED_NLOHMANN_JSON)
endif()
target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_14)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

# ##############################################################################
# TESTS
# ##############################################################################

if(CPP_JWT_BUILD_TESTS)
  find_package(GTest REQUIRED)
  include_directories(${GTEST_INCLUDE_DIRS})
  enable_testing()
  # Recurse into the "Hello" and "Demo" subdirectories. This does not actually
  # cause another cmake executable to run. The same process will walk through
  # the project's entire directory structure.
  add_subdirectory(tests)
endif()

# ##############################################################################
# EXAMPLES
# ##############################################################################

if(CPP_JWT_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

# ##############################################################################
# INSTALL
# ##############################################################################

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
set(CPP_JWT_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}Targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(
  EXPORT ${PROJECT_NAME}Targets
  DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR}
  NAMESPACE ${PROJECT_NAME}::
  COMPONENT dev)
configure_package_config_file(cmake/Config.cmake.in ${PROJECT_NAME}Config.cmake
                              INSTALL_DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR})
write_basic_package_version_file(${PROJECT_NAME}ConfigVersion.cmake
                                 COMPATIBILITY SameMajorVersion)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
  DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR}
  COMPONENT dev)

install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/detail
  DESTINATION include/jwt
  COMPONENT dev)
install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/impl
  DESTINATION include/jwt
  COMPONENT dev)
install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/json
  DESTINATION include/jwt
  COMPONENT dev)
install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/
  DESTINATION include/jwt
  COMPONENT dev
  FILES_MATCHING
  PATTERN "*.hpp")

=== debian/control ===
Source: cpp-jwt
Section: libdevel
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
Build-Depends-Indep:
 cmake (>= 3.14),
 libgtest-dev <!nocheck>,
 libssl-dev,
 nlohmann-json3-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/arun11299/cpp-jwt
Vcs-Git: https://salsa.debian.org/debian/cpp-jwt.git
Vcs-Browser: https://salsa.debian.org/debian/cpp-jwt
X-Style: black

Package: libcpp-jwt-dev
Architecture: all
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libssl-dev,
 nlohmann-json3-dev,
 ${misc:Depends},
Description: JSON Web Token library for C++
 JSON Web Token (JWT) is a JSON based standard (RFC-7519) for creating
 assertions or access tokens.
 .
 cpp-jwt, an header-only C++ library, provides an easy to use API to
 create, encode and decode JWT objects.

## cpp-jwt 1.4+ds

=== examples/CMakeLists.txt ===
set(CERT_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/rsa_256")
set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -DCERT_ROOT_DIR=\"\\\"${CERT_ROOT_DIR}\\\"\"")

add_executable(simple_ex1 simple_ex1.cc)
target_link_libraries(simple_ex1 ${PROJECT_NAME})
add_test(
  NAME simple_ex1
  COMMAND ./simple_ex1
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_executable(simple_ex2 simple_ex2.cc)
target_link_libraries(simple_ex2 ${PROJECT_NAME})
add_test(
  NAME simple_ex2
  COMMAND ./simple_ex2
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_executable(simple_ex3_rsa simple_ex3_rsa.cc)
target_link_libraries(simple_ex3_rsa ${PROJECT_NAME})
add_test(
  NAME simple_ex3_rsa
  COMMAND ./simple_ex3_rsa
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
cpp-jwt (1.4+ds-4) unstable; urgency=medium

  * d/patches: use find_dependency in CMake Config file
  * d/patches: fix side channel exploitable through timing attack.
    Thanks to Erwan Legrand for the report and the fix!

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 09 Apr 2024 11:14:04 +0200

cpp-jwt (1.4+ds-3) unstable; urgency=medium

  * d/control: mark libcpp-jwt-dev as Multi-Arch: foreign

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 27 Dec 2022 14:31:31 +0100

cpp-jwt (1.4+ds-2) unstable; urgency=medium

  * d/tests/cmake: suppress psABI warning on ARM

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 24 Aug 2022 23:28:11 +0200

cpp-jwt (1.4+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1016833)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 09 Aug 2022 10:13:41 +0200

=== debian/control ===
Source: cpp-jwt
Section: libdevel
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: cmake (>= 3.14),
                     libgtest-dev <!nocheck>,
                     libssl-dev,
                     nlohmann-json3-dev
Standards-Version: 4.6.2
Homepage: https://github.com/arun11299/cpp-jwt
Vcs-Git: https://salsa.debian.org/debian/cpp-jwt.git
Vcs-Browser: https://salsa.debian.org/debian/cpp-jwt
Rules-Requires-Root: no

Package: libcpp-jwt-dev
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libssl-dev,
         nlohmann-json3-dev
Description: JSON Web Token library for C++
 JSON Web Token (JWT) is a JSON based standard (RFC-7519) for creating
 assertions or access tokens.
 .
 cpp-jwt, an header-only C++ library, provides an easy to use API to
 create, encode and decode JWT objects.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  test := true
else
  test := false
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCPP_JWT_BUILD_EXAMPLES=false \
		-DCPP_JWT_BUILD_TESTS=$(test) \
		-DCPP_JWT_USE_VENDORED_NLOHMANN_JSON=false

execute_after_dh_auto_install:
	rmdir debian/libcpp-jwt-dev/usr/include/jwt/test

=== debian/tests/control ===
Tests: cmake
Depends: @, g++ | c++-compiler, cmake

## cpp-jwt 1.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.5.0)
-project(cpp-jwt VERSION 1.2.0)
+cmake_minimum_required(VERSION 3.14.0)
+project(cpp-jwt VERSION 1.5.0)
 
 option(CPP_JWT_BUILD_EXAMPLES "build examples" ON)
 option(CPP_JWT_BUILD_TESTS "build tests" ON)
@@ -24,7 +24,7 @@
 
 endif()
 
-find_package(OpenSSL REQUIRED)
+find_package(OpenSSL REQUIRED SSL)
 
 if(NOT CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
   find_package(nlohmann_json REQUIRED)
@@ -43,7 +43,7 @@
 if(NOT CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
   target_link_libraries(${PROJECT_NAME} INTERFACE nlohmann_json::nlohmann_json)
 else()
-  add_definitions(-DCPP_JWT_USE_VENDORED_NLOHMANN_JSON)
+  target_compile_definitions(${PROJECT_NAME} INTERFACE CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
 endif()
 target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_14)
 add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
@@ -76,44 +76,35 @@
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
-set(CPP_JWT_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
+set(CPP_JWT_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME})
 
-install(
-  TARGETS ${PROJECT_NAME}
-  EXPORT ${PROJECT_NAME}Targets
-  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets)
 install(
   EXPORT ${PROJECT_NAME}Targets
   DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR}
   NAMESPACE ${PROJECT_NAME}::
   COMPONENT dev)
 configure_package_config_file(cmake/Config.cmake.in ${PROJECT_NAME}Config.cmake
-                              INSTALL_DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR})
+                              INSTALL_DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR}
+                              NO_SET_AND_CHECK_MACRO)
 write_basic_package_version_file(${PROJECT_NAME}ConfigVersion.cmake
-                                 COMPATIBILITY SameMajorVersion)
+                                 COMPATIBILITY SameMajorVersion
+                                 ARCH_INDEPENDENT)
 install(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
         ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
   DESTINATION ${CPP_JWT_CONFIG_INSTALL_DIR}
   COMPONENT dev)
 
-install(
-  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/detail
-  DESTINATION include/jwt
-  COMPONENT dev)
-install(
-  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/impl
-  DESTINATION include/jwt
-  COMPONENT dev)
-install(
-  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/json
-  DESTINATION include/jwt
-  COMPONENT dev)
+if(NOT CPP_JWT_USE_VENDORED_NLOHMANN_JSON)
+  set(CPP_JWT_VENDORED_NLOHMANN_JSON_INSTALL_PATTERN PATTERN "json" EXCLUDE)
+endif()
 install(
   DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/jwt/
-  DESTINATION include/jwt
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/jwt
   COMPONENT dev
   FILES_MATCHING
-  PATTERN "*.hpp")
+  PATTERN "*.hpp"
+  PATTERN "*.ipp"
+  PATTERN "test" EXCLUDE
+  ${CPP_JWT_VENDORED_NLOHMANN_JSON_INSTALL_PATTERN})

=== debian/changelog ===
cpp-jwt (1.5+ds-1) experimental; urgency=low

  * New upstream version 1.5+ds
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <tachi@debian.org>  Sun, 15 Jun 2025 15:06:53 +0200

cpp-jwt (1.4+ds-5) unstable; urgency=low

  * First dgit upload
  * d/control: apply X-Style black
  * d/control: use my @debian.org email address
  * d/control: declare dpkg-build-api = 1
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 09 Apr 2025 15:53:57 +0200

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,3 @@
 		-DCPP_JWT_BUILD_EXAMPLES=false \
 		-DCPP_JWT_BUILD_TESTS=$(test) \
 		-DCPP_JWT_USE_VENDORED_NLOHMANN_JSON=false
-
-execute_after_dh_auto_install:
-	rmdir debian/libcpp-jwt-dev/usr/include/jwt/test
